/**
    * @license
    * Copyright 2021 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
import{slice,add,div,sub,mul,concat2d,Tensor,tidy,concat,tensor1d,squeeze,tensor2d,image,sigmoid,reshape,browser,expandDims,cast}from"@tensorflow/tfjs-core";import{loadGraphModel}from"@tensorflow/tfjs-converter";function __awaiter(e,t,n,r){return new(n||(n=Promise))(function(o,i){function a(e){try{c(r.next(e))}catch(e){i(e)}}function s(e){try{c(r.throw(e))}catch(e){i(e)}}function c(e){e.done?o(e.value):new n(function(t){t(e.value)}).then(a,s)}c((r=r.apply(e,t||[])).next())})}function __generator(e,t){var n,r,o,i,a={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return i={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function s(i){return function(s){return function(i){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(o=2&i[0]?r.return:i[0]?r.throw||((o=r.return)&&o.call(r),0):r.next)&&!(o=o.call(r,i[1])).done)return o;switch(r=0,o&&(i=[2&i[0],o.value]),i[0]){case 0:case 1:o=i;break;case 4:return a.label++,{value:i[1],done:!1};case 5:a.label++,r=i[1],i=[0];continue;case 7:i=a.ops.pop(),a.trys.pop();continue;default:if(!(o=(o=a.trys).length>0&&o[o.length-1])&&(6===i[0]||2===i[0])){a=0;continue}if(3===i[0]&&(!o||i[1]>o[0]&&i[1]<o[3])){a.label=i[1];break}if(6===i[0]&&a.label<o[1]){a.label=o[1],o=i;break}if(o&&a.label<o[2]){a.label=o[2],a.ops.push(i);break}o[2]&&a.ops.pop(),a.trys.pop();continue}i=t.call(e,a)}catch(e){i=[6,e],r=0}finally{n=o=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,s])}}}var disposeBox=function(e){e.startEndTensor.dispose(),e.startPoint.dispose(),e.endPoint.dispose()},createBox=function(e){return{startEndTensor:e,startPoint:slice(e,[0,0],[-1,2]),endPoint:slice(e,[0,2],[-1,2])}},scaleBox=function(e,t){var n=mul(e.startPoint,t),r=mul(e.endPoint,t),o=concat2d([n,r],1);return createBox(o)},ANCHORS_CONFIG={strides:[8,16],anchors:[2,6]},NUM_LANDMARKS=6;function generateAnchors(e,t,n){for(var r=[],o=0;o<n.strides.length;o++)for(var i=n.strides[o],a=Math.floor((t+i-1)/i),s=Math.floor((e+i-1)/i),c=n.anchors[o],u=0;u<a;u++)for(var l=i*(u+.5),d=0;d<s;d++)for(var h=i*(d+.5),f=0;f<c;f++)r.push([h,l]);return r}function decodeBounds(e,t,n){var r=slice(e,[0,1],[-1,2]),o=add(r,t),i=slice(e,[0,3],[-1,2]),a=div(i,n),s=div(o,n),c=div(a,2),u=sub(s,c),l=add(s,c),d=mul(u,n),h=mul(l,n);return concat2d([d,h],1)}function getInputTensorDimensions(e){return e instanceof Tensor?[e.shape[0],e.shape[1]]:[e.height,e.width]}function flipFaceHorizontal(e,t){var n,r,o;if(e.topLeft instanceof Tensor&&e.bottomRight instanceof Tensor){var i=tidy(function(){return[concat([slice(sub(t-1,e.topLeft),0,1),slice(e.topLeft,1,1)]),concat([sub(t-1,slice(e.bottomRight,0,1)),slice(e.bottomRight,1,1)])]});n=i[0],r=i[1],null!=e.landmarks&&(o=tidy(function(){var n=sub(tensor1d([t-1,0]),e.landmarks),r=tensor1d([1,-1]);return mul(n,r)}))}else{var a=e.topLeft,s=a[0],c=a[1],u=e.bottomRight,l=u[0],d=u[1];n=[t-1-s,c],r=[t-1-l,d],null!=e.landmarks&&(o=e.landmarks.map(function(e){return[t-1-e[0],e[1]]}))}var h={topLeft:n,bottomRight:r};return null!=o&&(h.landmarks=o),null!=e.probability&&(h.probability=e.probability instanceof Tensor?e.probability.clone():e.probability),h}function scaleBoxFromPrediction(e,t){return tidy(function(){var n;return n=e.hasOwnProperty("box")?e.box:e,squeeze(scaleBox(n,t).startEndTensor)})}var BlazeFaceModel=function(){function e(e,t,n,r,o,i){this.blazeFaceModel=e,this.width=t,this.height=n,this.maxFaces=r,this.anchorsData=generateAnchors(t,n,ANCHORS_CONFIG),this.anchors=tensor2d(this.anchorsData),this.inputSizeData=[t,n],this.inputSize=tensor1d([t,n]),this.iouThreshold=o,this.scoreThreshold=i}return e.prototype.getBoundingBoxes=function(e,t,n){return void 0===n&&(n=!0),__awaiter(this,void 0,void 0,function(){var r,o,i,a,s,c,u,l,d,h,f,p,b,m,v=this;return __generator(this,function(y){switch(y.label){case 0:return r=tidy(function(){var t=image.resizeBilinear(e,[v.width,v.height]),n=mul(sub(div(t,255),.5),2),r=v.blazeFaceModel.predict(n),o=squeeze(r),i=decodeBounds(o,v.anchors,v.inputSize),a=slice(o,[0,0],[-1,1]);return[o,i,squeeze(sigmoid(a))]}),o=r[0],i=r[1],a=r[2],s=console.warn,console.warn=function(){},c=image.nonMaxSuppression(i,a,this.maxFaces,this.iouThreshold,this.scoreThreshold),console.warn=s,[4,c.array()];case 1:return u=y.sent(),c.dispose(),l=u.map(function(e){return slice(i,[e,0],[1,-1])}),t?[3,3]:[4,Promise.all(l.map(function(e){return __awaiter(v,void 0,void 0,function(){var t;return __generator(this,function(n){switch(n.label){case 0:return[4,e.array()];case 1:return t=n.sent(),e.dispose(),[2,t]}})})}))];case 2:l=y.sent(),y.label=3;case 3:for(d=e.shape[1],h=e.shape[2],f=t?div([h,d],this.inputSize):[h/this.inputSizeData[0],d/this.inputSizeData[1]],p=[],b=function(e){var r=l[e],i=tidy(function(){var i=createBox(r instanceof Tensor?r:tensor2d(r));if(!n)return i;var s,c=u[e];return s=t?slice(v.anchors,[c,0],[1,2]):v.anchorsData[c],{box:i,landmarks:reshape(squeeze(slice(o,[c,NUM_LANDMARKS-1],[1,-1])),[NUM_LANDMARKS,-1]),probability:slice(a,[c],[1]),anchor:s}});p.push(i)},m=0;m<l.length;m++)b(m);return i.dispose(),a.dispose(),o.dispose(),[2,{boxes:p,scaleFactor:f}]}})})},e.prototype.estimateFaces=function(e,t,n,r){return void 0===t&&(t=!1),void 0===n&&(n=!1),void 0===r&&(r=!0),__awaiter(this,void 0,void 0,function(){var o,i,a,s,c,u,l=this;return __generator(this,function(d){switch(d.label){case 0:return o=getInputTensorDimensions(e),i=o[1],a=tidy(function(){return e instanceof Tensor||(e=browser.fromPixels(e)),expandDims(cast(e,"float32"),0)}),[4,this.getBoundingBoxes(a,t,r)];case 1:return s=d.sent(),c=s.boxes,u=s.scaleFactor,a.dispose(),t?[2,c.map(function(e){var t=scaleBoxFromPrediction(e,u),o={topLeft:slice(t,[0],[2]),bottomRight:slice(t,[2],[2])};if(r){var a=e,s=a.landmarks,c=a.probability,l=a.anchor,d=mul(add(s,l),u);o.landmarks=d,o.probability=c}return n&&(o=flipFaceHorizontal(o,i)),o})]:[2,Promise.all(c.map(function(e){return __awaiter(l,void 0,void 0,function(){var t,o,a,s,c,l,d,h,f,p,b,m=this;return __generator(this,function(v){switch(v.label){case 0:return t=scaleBoxFromPrediction(e,u),r?[3,2]:[4,t.array()];case 1:return c=v.sent(),o={topLeft:c.slice(0,2),bottomRight:c.slice(2)},[3,4];case 2:return[4,Promise.all([e.landmarks,t,e.probability].map(function(e){return __awaiter(m,void 0,void 0,function(){return __generator(this,function(t){return[2,e.array()]})})}))];case 3:a=v.sent(),s=a[0],c=a[1],l=a[2],d=e.anchor,f=(h=u)[0],p=h[1],b=s.map(function(e){return[(e[0]+d[0])*f,(e[1]+d[1])*p]}),o={topLeft:c.slice(0,2),bottomRight:c.slice(2),landmarks:b,probability:l},disposeBox(e.box),e.landmarks.dispose(),e.probability.dispose(),v.label=4;case 4:return t.dispose(),n&&(o=flipFaceHorizontal(o,i)),[2,o]}})})}))]}})})},e}(),BLAZEFACE_MODEL_URL="https://tfhub.dev/tensorflow/tfjs-model/blazeface/1/default/1";function load(e){var t=void 0===e?{}:e,n=t.maxFaces,r=void 0===n?10:n,o=t.inputWidth,i=void 0===o?128:o,a=t.inputHeight,s=void 0===a?128:a,c=t.iouThreshold,u=void 0===c?.3:c,l=t.scoreThreshold,d=void 0===l?.75:l;return __awaiter(this,void 0,void 0,function(){var e;return __generator(this,function(t){switch(t.label){case 0:return[4,loadGraphModel(BLAZEFACE_MODEL_URL,{fromTFHub:!0})];case 1:return e=t.sent(),[2,new BlazeFaceModel(e,i,s,r,u,d)]}})})}export{load,BlazeFaceModel};
